package org.openxma.demo.customer;

import java.util.Locale;

import org.openxma.dsl.platform.enums.I18nEnum;
import org.openxma.dsl.platform.enums.I18nEnums;

public enum CategoryEnum implements I18nEnum {
    A("A"),
    B("B"),
    C("C");

    private String key;

    private CategoryEnum(String key) {
        this.key = key;
    }

    public String getKey() {
        return this.key;
    }

    public String getLongValue(Locale locale) {
        return I18nEnums.longValueFromProvider(this, locale);
    }

    public String getShortValue(Locale locale) {
        return I18nEnums.shortValueFromProvider(this, locale);
    }

    public static CategoryEnum valueOfKey(String key) {
        return I18nEnums.valueOfKey(CategoryEnum.class,key);
    }
}
