package org.openxma.demo.customer.jsf.converter;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;
import javax.faces.convert.ConverterException;
import javax.faces.convert.FacesConverter;

import org.owasp.validator.html.AntiSamy;
import org.owasp.validator.html.Policy;
import org.owasp.validator.html.PolicyException;
import org.owasp.validator.html.ScanException;
import org.springframework.stereotype.Component;

@FacesConverter("org.openxma.demo.stripHtmlConverter")
public class StripHtmlConverter implements Converter {
	
	private static final String ANTISAMY_TINYMCE_POLICY = "antisamy-tinymce-1.4.4.xml";
	private static AntiSamy antiSamy;

	private String strip(String string) {
		try {
			lazyLoadPolicy();
			String cleanHTML = antiSamy.scan(string).getCleanHTML();
			return cleanHTML;
		} catch (ScanException e) {
			e.printStackTrace();
			return string;
		} catch (PolicyException e) {
			e.printStackTrace();
			return string;
		}
	}

	public void lazyLoadPolicy() throws PolicyException {
		if (antiSamy == null) {
			Policy policy = Policy.getInstance(this.getClass().getClassLoader().getResourceAsStream(ANTISAMY_TINYMCE_POLICY));
			antiSamy = new AntiSamy(policy);
		}
	}
	
	@Override
	public Object getAsObject(FacesContext ctx, UIComponent comp, String string)
			throws ConverterException {
		return strip(string);
	}

	@Override
	public String getAsString(FacesContext ctx, UIComponent comp, Object object)
			throws ConverterException {
		return strip((String) object);
	}

}
