package org.openxma.demo.customer.model.impl;

import java.math.BigDecimal;
import java.util.Date;
import org.openxma.demo.customer.Address;
import org.openxma.demo.customer.CategoryEnum;
import org.openxma.demo.customer.model.Customer;

public abstract class CustomerGenImpl implements Customer {
	protected String oid;
	protected Date version;
	protected String firstName;
	protected String lastName;
	protected String emailAddress;
	protected Date birthDate;
	protected Address invoiceAddress = new Address();
	protected Address deliveryAddress = new Address();
	protected Boolean vip;
	protected CategoryEnum category;
	protected BigDecimal buyLimit;
	
	public String getOid() {
		return this.oid;
	}
	
	public void setOid(String oid) {
		this.oid = oid;
	}
	
	public Date getVersion() {
		return this.version;
	}
	
	public void setVersion(Date version) {
		this.version = version;
	}
	
	public String getFirstName() {
		return this.firstName;
	}
	
	public void setFirstName(String firstName) {
		this.firstName = firstName;
	}
	
	public String getLastName() {
		return this.lastName;
	}
	
	public void setLastName(String lastName) {
		this.lastName = lastName;
	}
	
	public String getEmailAddress() {
		return this.emailAddress;
	}
	
	public void setEmailAddress(String emailAddress) {
		this.emailAddress = emailAddress;
	}
	
	public Date getBirthDate() {
		return this.birthDate;
	}
	
	public void setBirthDate(Date birthDate) {
		this.birthDate = birthDate;
	}
	
	public Address getInvoiceAddress() {
		return this.invoiceAddress;
	}
	
	public void setInvoiceAddress(Address invoiceAddress) {
		this.invoiceAddress = invoiceAddress;
	}
	
	public Address getDeliveryAddress() {
		return this.deliveryAddress;
	}
	
	public void setDeliveryAddress(Address deliveryAddress) {
		this.deliveryAddress = deliveryAddress;
	}
	
	public Boolean getVip() {
		return this.vip;
	}
	
	public void setVip(Boolean vip) {
		this.vip = vip;
	}
	
	public CategoryEnum getCategory() {
		return this.category;
	}
	
	public void setCategory(CategoryEnum category) {
		this.category = category;
	}
	
	public BigDecimal getBuyLimit() {
		return this.buyLimit;
	}
	
	public void setBuyLimit(BigDecimal buyLimit) {
		this.buyLimit = buyLimit;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((getOid() == null) ? 0 : getOid().hashCode());
		return result;
	}
	
	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (!(obj instanceof Customer)) {
			return false;
		}
		Customer other = (Customer) obj;
		if (getOid() == null) {
			if (other.getOid() != null) {
				return false;
			}
		} else if (!getOid().equals(other.getOid())) {
			return false;
		}
		return true;
	}
	
	@Override
	public String toString() {
		StringBuilder toStringBuilder = new StringBuilder("Customer [");
		toStringBuilder.append("oid=").append(getOid()).append(",");
		toStringBuilder.append("version=").append(getVersion()).append(",");
		toStringBuilder.append("firstName=").append(getFirstName()).append(",");
		toStringBuilder.append("lastName=").append(getLastName()).append(",");
		toStringBuilder.append("emailAddress=").append(getEmailAddress()).append(",");
		toStringBuilder.append("birthDate=").append(getBirthDate()).append(",");
		toStringBuilder.append("vip=").append(getVip()).append(",");
		toStringBuilder.append("category=").append(getCategory()).append(",");
		toStringBuilder.append("buyLimit=").append(getBuyLimit());
		return toStringBuilder.append("]").toString();
	}
}
