namespace org.openxma.demo.customer.^xma
import org.openxma.demo.customer.*

component xma::CustomerComponent uses CustomerDas {

    page CustomerSearchForm "Customer Search" {
	    data Customer   customer 
	    data Customer[] customers
        command findCustomer
        uicommand editSelectedCustomer : invoke CustomerEditForm customerTable.getSelectedValue() -> customerOid
        uicommand newCustomer : invoke CustomerEditForm '' -> customerOid

        eventmapping {
            onInit 		 -> findCustomer
            findButton   -> findCustomer
            customerTable.onDoubleClick -> editSelectedCustomer
            newButton	->  newCustomer
        }

        panel searchForm {
        	button newButton "New customer ..."
	        vpanel customerTableHeader {
	            label headerText "Customers:" left=0
	            customer.firstName 
	            customer.lastName & button findButton "Find"
	        }
	        table customerTable key=customers.oid top=customerTableHeader bottom=100% {
	            customers.firstName    width=80
	            customers.lastName     width=140
	            customers.birthDate    width=140
	            customers.emailAddress width=140
	        }
        }
    }

    page CustomerEditForm "Customer Edit" {
    	property String customerOid
	    data Customer   customer
    	
        command readCustomer
        command saveCustomer

        eventmapping {
            onInit 		 -> readCustomer
            okButton     -> saveCustomer, closeOK
            cancelButton -> closeCancel
        }

        panel editForm {
            tabfolder tabfolder1 top=0 bottom=actionComposite {
                tabpage Page1 "Basic Information" {
                    vpanel infoComposite top=10  {
                        customer.firstName
                        customer.lastName
                        customer.emailAddress
                        customer.birthDate
                    }
                }
                
            }
            hpanel actionComposite bottom=100% align=right {
                button okButton "Ok" style=primaryStyle
                button cancelButton "Cancel"
            }
        }
    }
}

style primaryStyle {
	widget-style: style-primary
}




