package org.openxma.demo.customer.xma.backingbean;

import javax.faces.application.FacesMessage;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;

import org.openxma.demo.customer.dto.CustomerView;
import org.primefaces.component.commandbutton.CommandButton;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/** 
 * Backing Bean for Page CustomerEditForm 
 */
@Component("customerEditForm")
@Scope("access")
public class CustomerEditForm extends CustomerEditFormGen {

	@Override
	public void readCustomer() {
		if (customerOid != null)   
			customer = component.customerDas.loadCustomerView(customerOid);
		else
			customer = new CustomerView();
	}

	@Override
	public void saveCustomer() {
		customer = component.customerDas.saveOrUpdate(customer);
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage(FacesMessage.SEVERITY_INFO, "Saved Customer", "Customer successfully saved to DB"));
	}
	

	@Override
	public void customizeView(UIViewRoot viewRoot) {
		CommandButton okButton = (CommandButton) viewRoot.findComponent(OK_BUTTON_ID);
		okButton.setOncomplete("if (!args.validationFailed) App.customerEditForm.closeOK();");
	}

}
