package org.openxma.demo.customer.xma.backingbean;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import org.openxma.demo.customer.dto.CustomerView;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page CustomerEditForm 
 */
public abstract class CustomerEditFormGen extends PageBackingBean {
	
	// client id constants
	
	public static String EDIT_FORM_ID = "CustomerEditFormForm:editForm";
	public static String TABFOLDER1_ID = "CustomerEditFormForm:tabfolder1";
	public static String PAGE1_ID = "CustomerEditFormForm:Page1";
	public static String INFO_COMPOSITE_ID = "CustomerEditFormForm:infoComposite";
	public static String ACTION_COMPOSITE_ID = "CustomerEditFormForm:actionComposite";
	public static String OK_BUTTON_ID = "CustomerEditFormForm:okButton";
	public static String CANCEL_BUTTON_ID = "CustomerEditFormForm:cancelButton";
	
	
	@Autowired
	protected CustomerComponent component;
	
	public CustomerComponent getTypedComponent() {
		return component;
	}
	
	protected String customerOid;
	
	
    // data objects
    protected CustomerView customer;
    
    // jsf data models
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
            readCustomer();
    }
    
    // commands
	public abstract void readCustomer();
	public abstract void saveCustomer();
    
    // conditions

    public String getCustomerOid() {
        return customerOid;
    }
    public void setCustomerOid(String customerOid) {
        this.customerOid = customerOid;
    }

	public CustomerView getCustomer() {
	    return customer;
	}
	public void setCustomer(CustomerView customer) {
	    this.customer = customer;
	}
	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected CustomerEditFormGen getContext() {
		return this;
	}
	protected void processConditions() {
	}

}
