package org.openxma.demo.customer.xma.backingbean;

import javax.faces.component.UIViewRoot;

import org.openxma.demo.customer.dto.CustomerView;
import org.primefaces.component.inputtext.InputText;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/** 
 * Backing Bean for Page CustomerSearchForm 
 */
@Component("customerSearchForm")
@Scope("access")
public class CustomerSearchForm extends CustomerSearchFormGen {

	@Override
	public void customizeView(UIViewRoot viewRoot) {
		InputText firstName = (InputText) viewRoot.findComponent("CustomerSearchFormForm:firstName1");
		firstName.setRequired(false);
		InputText lastName = (InputText) viewRoot.findComponent("CustomerSearchFormForm:lastName1");
		lastName.setRequired(false);
	}
	@Override
	public void findCustomer() {
		if (customer == null) {
			customer = new CustomerView();
		}
		String firstName = customer.getFirstName() != null ? customer.getFirstName() : "";
		String lastName = customer.getLastName() != null ? customer.getLastName() : "";
		customers = component.customerDas.findAllLikeName("%" + firstName+"%", "%" + lastName+"%");
		customerTableTableModel.setWrappedData(customers);
		System.out.println("Found " + customers.size() + " customers.");
	}
}
