package org.openxma.demo.customer.xma.jsfcomponent.backingbean;

import static org.openxma.dsl.platform.jsf.util.JsfUtil.redirectToPage;

import javax.faces.application.FacesMessage;
import javax.faces.context.FacesContext;

import org.apache.myfaces.orchestra.viewController.annotations.ViewController;
import org.openxma.demo.customer.CategoryEnum;
import org.openxma.dsl.platform.jsf.util.I18nEnumUtil;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;


/** 
 * Backing Bean for CDetailPage 
 */
@Component("cDetailPage")
@Scope("access")
@ViewController(viewIds={"pages/JsfComponent/cDetailPage.xhtml"})
public class CDetailPage extends CDetailPageGen {

	@Override
	public void saveOrUpdate() {
		customerDas.saveOrUpdate(component.getCustomer());
		// re-load the customer since we stay on the page 
		component.setCustomer(customerDas.loadCustomerView(component.getCustomer().getOid()));
		FacesContext.getCurrentInstance().addMessage(null, new FacesMessage("Saved Customer", "Customer successfully saved to DB"));
	}
	
	@Override
	public void invokeSearchPage() {
		redirectToPage(CSearchPage.class);
		
	}

	@Override
	public void initGui() {
		category1SelectItems = I18nEnumUtil.getSelectItemsForI18nEnumValues(false, CategoryEnum.values());
		
	}
}
