package org.openxma.demo.customer.xma.jsfcomponent.backingbean;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import javax.faces.model.SelectItem;
import org.openxma.demo.customer.service.CustomerDas;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page CDetailPage 
 */
public abstract class CDetailPageGen extends PageBackingBean {
	
	// client id constants
	
	public static String S_FORM_ID = "CDetailPageForm:sForm";
	public static String CUSTOMER_DETAILS_ID = "CDetailPageForm:customerDetails";
	public static String SAVE_BUTTON_ID = "CDetailPageForm:saveButton";
	public static String BACK_BUTTON_ID = "CDetailPageForm:backButton";
	
	
	@Autowired
	protected JsfComponent component;
	
	public JsfComponent getTypedComponent() {
		return component;
	}
	
		@Autowired
	protected CustomerDas customerDas;
	protected String customerId;
	protected Boolean edit;
	
	
    // data objects
    
    // jsf data models
    protected List<SelectItem> category1SelectItems;
    
    public List getCategory1SelectItems() {
        return category1SelectItems;
    }
    public void setCategory1SelectItems(List category1SelectItems) {
        this.category1SelectItems = category1SelectItems;
    }
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
            initGui();
    }
    
    // commands
	public abstract void initGui();
	public abstract void saveOrUpdate();
	public abstract void invokeSearchPage();
    
    // conditions

    public String getCustomerId() {
        return customerId;
    }
    public void setCustomerId(String customerId) {
        this.customerId = customerId;
    }
    public Boolean getEdit() {
        return edit;
    }
    public void setEdit(Boolean edit) {
        this.edit = edit;
    }

	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected CDetailPageGen getContext() {
		return this;
	}
	protected void processConditions() {
	}

}
