package org.openxma.demo.customer.xma.jsfcomponent.backingbean;

import static org.openxma.dsl.platform.jsf.util.JsfUtil.redirectToPage;

import javax.faces.component.UIViewRoot;

import org.apache.myfaces.orchestra.viewController.annotations.ViewController;
import org.openxma.demo.customer.dto.CustomerView;
import org.primefaces.component.datatable.DataTable;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;


/** 
 * Backing Bean for CSearchPage 
 */
@Component("cSearchPage")
@Scope("access")
@ViewController(viewIds={"pages/JsfComponent/cSearchPage.xhtml"})
public class CSearchPage extends CSearchPageGen {
	
	@Override
	public void customizeView(UIViewRoot viewRoot) {
		DataTable dataTable = (DataTable) viewRoot.findComponent(CUSTOMER_TABLE_ID);
		dataTable.setRows(20);
	}

	@Override
	public void findCustomer() {
		if  ("c".equals(searchCustomer.getFirstName())) {
			throw new IllegalArgumentException("Test Error");
		}
		System.out.println("findCustomer %" + searchCustomer.getFirstName()+"%" + " / " + "%" + searchCustomer.getLastName()+"%");
		foundCustomers = customerDas.findAllLikeName("%" + searchCustomer.getFirstName()+"%", "%" + searchCustomer.getLastName()+"%");
		System.out.println("Found " + foundCustomers.size() + " customers.");
		customerTableTableModel.setWrappedData(foundCustomers);
	}
	
	@Override
	public void selectCustomer() {
		component.setCustomer(customerTableTableModel.getSelectedItem());
	}

	@Override
	public void editDetails() {
		System.out.println("editDetails");
		redirectToPage(CDetailPage.class);
	}

	@Override
	public void initGui() {
		component.setCustomer(new CustomerView());
		searchCustomer = new CustomerView();
		searchCustomer.setFirstName("");
		searchCustomer.setLastName("");
	}


}
