package org.openxma.demo.customer.xma.jsfcomponent.backingbean;
import java.util.Collection;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import org.openxma.demo.customer.dto.CustomerView;
import org.openxma.demo.customer.service.CustomerDas;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.openxma.dsl.platform.jsf.model.MapDataModel;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page CSearchPage 
 */
public abstract class CSearchPageGen extends PageBackingBean {
	
	// client id constants
	
	public static String S_FORM_ID = "CSearchPageForm:sForm";
	public static String CUSTOMER_TABLE_HEADER_ID = "CSearchPageForm:customerTableHeader";
	public static String FIND_BUTTON_ID = "CSearchPageForm:findButton";
	public static String CUSTOMER_TABLE_ID = "CSearchPageForm:customerTable";
	public static String EDIT_BUTTON_ID = "CSearchPageForm:editButton";
	public static String TAB_FOLDER_ID = "CSearchPageForm:tabFolder";
	public static String FIRST_TAB_ID = "CSearchPageForm:firstTab";
	public static String SECOND_TAB_ID = "CSearchPageForm:secondTab";
	public static String MY_TEXT2_ID = "CSearchPageForm:myText21";
	
	
	@Autowired
	protected JsfComponent component;
	
	public JsfComponent getTypedComponent() {
		return component;
	}
	
		@Autowired
	protected CustomerDas customerDas;
	protected String myPageProperty;
	protected Integer myPageProperty1;
	
	
    // data objects
    protected CustomerView searchCustomer;
    protected Collection<CustomerView> foundCustomers;
    
    // jsf data models
    protected MapDataModel<String,CustomerView> customerTableTableModel = new MapDataModel<String,CustomerView>() {
    	public String getRowKey(CustomerView row) {
    		return row.getOid();
    	}
    };
    
    public MapDataModel getCustomerTableTableModel() {
        return customerTableTableModel;
    }
    public void setCustomerTableTableModel(MapDataModel customerTableTableModel) {
        this.customerTableTableModel = customerTableTableModel;
    }
    protected String myText2Text = "";
    
    public String getMyText2Text() {
        return myText2Text;
    }
    public void setMyText2Text(String myText2Text) {
        this.myText2Text = myText2Text;
    }
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
            initGui();
            findCustomer();
    }
    
    // commands
	public abstract void findCustomer();
	public abstract void initGui();
	public abstract void selectCustomer();
	public abstract void editDetails();
    
    // conditions

    public String getMyPageProperty() {
        return myPageProperty;
    }
    public void setMyPageProperty(String myPageProperty) {
        this.myPageProperty = myPageProperty;
    }
    public Integer getMyPageProperty1() {
        return myPageProperty1;
    }
    public void setMyPageProperty1(Integer myPageProperty1) {
        this.myPageProperty1 = myPageProperty1;
    }

	public CustomerView getSearchCustomer() {
	    return searchCustomer;
	}
	public void setSearchCustomer(CustomerView searchCustomer) {
	    this.searchCustomer = searchCustomer;
	}
	public Collection getFoundCustomers() {
	    return foundCustomers;
	}
	public void setFoundCustomers(Collection foundCustomers) {
	    this.foundCustomers = foundCustomers;
	}
	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected CSearchPageGen getContext() {
		return this;
	}
	protected void processConditions() {
	}

}
