package org.openxma.demo.customer.xma.jsfcomponent.backingbean;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page ConditionsPage 
 */
public abstract class ConditionsPageGen extends PageBackingBean {
	
	// client id constants
	
	public static String ENABLE_BUTTON_ID = "ConditionsPageForm:enableButton";
	public static String DISABLE_BUTTON_ID = "ConditionsPageForm:disableButton";
	
	
	@Autowired
	protected JsfComponent component;
	
	public JsfComponent getTypedComponent() {
		return component;
	}
	
	protected Boolean edit;
	
	
    // data objects
    
    // jsf data models
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
    }
    
    // commands
	public abstract void enable();
	public abstract void disable();
    
    // conditions
    private boolean editMode;
    public Boolean getEditMode() {
        return editMode;
    }
    public void setEditMode(Boolean editMode) {
        this.editMode = editMode;
    }
    private boolean viewMode;
    public Boolean getViewMode() {
        return viewMode;
    }
    public void setViewMode(Boolean viewMode) {
        this.viewMode = viewMode;
    }

    public Boolean getEdit() {
        return edit;
    }
    public void setEdit(Boolean edit) {
        this.edit = edit;
    }

	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected ConditionsPageGen getContext() {
		return this;
	}
	protected void processConditions() {
		setEditMode(getContext().getEdit()==Boolean.TRUE);   
		setViewMode(getContext().getEdit()==Boolean.FALSE);   
	}

}
