package org.openxma.demo.customer.xma.jsfcomponent.backingbean;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import org.primefaces.model.DualListModel;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/** 
 * Backing Bean for Page TableCustomizerPage 
 */
@Component("tableCustomizerPage")
@Scope("access")
public class TableCustomizerPage extends TableCustomizerPageGen {
	
	private DualListModel<String> columns;
	private List<ColumnModel> selectedColumns;
	
	@Override
	public void dataModelInit() {
		List<String> source = Arrays.asList("oid", "firstName", "emailAddress");
		List<String> target = Arrays.asList("birthDate", "lastName");
		setColumns(new DualListModel<String>(source, target));
		apply();
	}

	@Override
	public void init() {
		customers = customerDas.findAllCustomers();
		customerTableTableModel.setWrappedData(customers);
	}
	
	public void apply() {
		selectedColumns = new ArrayList<ColumnModel>();
		for (String col : columns.getTarget()) {
			selectedColumns.add(new ColumnModel(col, col));
		}
	}

	public DualListModel<String> getColumns() {
		return columns;
	}

	public void setColumns(DualListModel<String> columns) {
		this.columns = columns;
	}
	
    public List<ColumnModel> getSelectedColumns() {
		return selectedColumns;
	}

	public void setSelectedColumns(List<ColumnModel> selectedColumns) {
		this.selectedColumns = selectedColumns;
	}

	@SuppressWarnings("serial")
	static public class ColumnModel implements Serializable {  
    	  
        private String header;  
        private String property;  
  
        public ColumnModel(String header, String property) {  
            this.header = header;  
            this.property = property;  
        }  
  
        public String getHeader() {  
            return header;  
        }  
  
        public String getProperty() {  
            return property;  
        }  
    }  

}
