package org.openxma.demo.customer.xma.jsfcomponent.backingbean;
import java.util.Collection;
import javax.annotation.PostConstruct;
import javax.faces.component.UIViewRoot;
import javax.faces.context.FacesContext;
import javax.faces.event.ComponentSystemEvent;
import org.openxma.demo.customer.dto.CustomerView;
import org.openxma.demo.customer.service.CustomerDas;
import org.openxma.dsl.platform.jsf.beans.PageBackingBean;
import org.openxma.dsl.platform.jsf.model.MapDataModel;
import org.springframework.beans.factory.annotation.Autowired;
/** 
 * Abstract Backing Bean Base for Page TableCustomizerPage 
 */
public abstract class TableCustomizerPageGen extends PageBackingBean {
	
	// client id constants
	
	public static String TABLE_PANEL_ID = "TableCustomizerPageForm:tablePanel";
	public static String CUSTOMER_TABLE_ID = "TableCustomizerPageForm:customerTable";
	
	
	@Autowired
	protected JsfComponent component;
	
	public JsfComponent getTypedComponent() {
		return component;
	}
	
		@Autowired
	protected CustomerDas customerDas;
	
	
    // data objects
    protected Collection<CustomerView> customers;
    
    // jsf data models
    protected MapDataModel<String,CustomerView> customerTableTableModel = new MapDataModel<String,CustomerView>() {
    	public String getRowKey(CustomerView row) {
    		return row.getOid();
    	}
    };
    
    public MapDataModel getCustomerTableTableModel() {
        return customerTableTableModel;
    }
    public void setCustomerTableTableModel(MapDataModel customerTableTableModel) {
        this.customerTableTableModel = customerTableTableModel;
    }
    
    // init data model
    protected void dataModelInit() {
    }
    
    // lifecycle events
    @PostConstruct
    public void beanInit() {
    	dataModelInit();
    	onInit();
    	onEnter();
    }
    
    public void invoke() {
    	onInit();
    	onEnter();
    }
    /**
     * PML onLoad event
     */
    protected void onEnter() {
    }
    
    /**
     * PML onLeave event
     */
    protected void onLeave() {
    }
    
    /**
     * PML onInit event
     */
    protected void onInit() {
            init();
    }
    
    // commands
	public abstract void init();
    
    // conditions


	public Collection getCustomers() {
	    return customers;
	}
	public void setCustomers(Collection customers) {
	    this.customers = customers;
	}
	
	public void handlePreRenderView(ComponentSystemEvent event){
		processConditions();
		if (!FacesContext.getCurrentInstance().isPostback()) {
			customizeView(FacesContext.getCurrentInstance().getViewRoot());
		}
	}
	
	protected void customizeView(UIViewRoot viewRoot) {
		//by default do nothing, override to add behaviour
	}
	protected TableCustomizerPageGen getContext() {
		return this;
	}
	protected void processConditions() {
	}

}
