package org.openxma.demo.customer.xma.jsfcomponent.backingbean;

import java.util.ArrayList;

import javax.faces.model.SelectItem;

import org.openxma.dsl.platform.jsf.util.JsfUtil;
import org.primefaces.model.DefaultTreeNode;
import org.primefaces.model.TreeNode;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;

/** 
 * Backing Bean for Page WidgetsPage 
 */
@Component("widgetsPage")
@Scope("access")
public class WidgetsPage extends WidgetsPageGen {
	
	@Override
	public void dataModelInit() {
		// init combo
		mycombo1SelectItems = new ArrayList<SelectItem>();
		mycombo1SelectItems.add(new SelectItem((Object) 15L, "15"));
		mycombo1SelectItems.add(new SelectItem((Object) 17L, "17"));
		mydisabledcombo1SelectItems = new ArrayList<SelectItem>();
		mydisabledcombo1SelectItems.add(new SelectItem((Object) 15L, "15"));
		mydisabledcombo1SelectItems.add(new SelectItem((Object) 17L, "17"));
		
		// init listbox
		mylistbox1SelectItems = new ArrayList<SelectItem>();
		mylistbox1SelectItems.add(new SelectItem("A", "Alpha"));
		mylistbox1SelectItems.add(new SelectItem("B", "Beta"));
		mylistbox1SelectItems.add(new SelectItem("C", "Cesar"));
		mydisabledlistbox1SelectItems = new ArrayList<SelectItem>();
		mydisabledlistbox1SelectItems.add(new SelectItem("A", "Alpha"));
		mydisabledlistbox1SelectItems.add(new SelectItem("B", "Beta"));
		mydisabledlistbox1SelectItems.add(new SelectItem("C", "Cesar"));
		
		// init tree
		mytreeTreeRootNode = new DefaultTreeNode("root", null);
		TreeNode n1 = new DefaultTreeNode("n1", mytreeTreeRootNode);
		TreeNode n2 = new DefaultTreeNode("n1", mytreeTreeRootNode);
		
		TreeNode n11 = new DefaultTreeNode("n11", n1);
		TreeNode n12 = new DefaultTreeNode("n12", n1);
		TreeNode n13 = new DefaultTreeNode("n13", n1);
		
		TreeNode n21 = new DefaultTreeNode("n21", n2);
		TreeNode n22 = new DefaultTreeNode("n22", n2);
		
		TreeNode n111 = new DefaultTreeNode("n111", n11);
		TreeNode n112 = new DefaultTreeNode("n112", n11);
		
	}
	
	@Override
	public void init() {
		mycomboCombo = 17L; // so it should be selected
		mycheckSelected = true;
		mydisabledtextText = "disabled";
		mytextText = "enabled";
	}
	
	@Override
	public void send() {
		JsfUtil.addMessage(null, "Selected", mycheckSelected.toString());
		JsfUtil.addMessage(null, "Combo", mycomboCombo != null ? mycomboCombo.toString() : "null");
		JsfUtil.addMessage(null, "ListBox", mylistboxListBox != null ? mylistboxListBox.toString() : "null");
		JsfUtil.addMessage(null, "Tree", mytreeTreeSelectedNode != null ? mytreeTreeSelectedNode.getData().toString() : "No selection");
	}

}
