package org.openxma.demo.customer.xma.presentation.backingbean;

import javax.annotation.PostConstruct;

import org.apache.myfaces.orchestra.viewController.annotations.ViewController;
import org.primefaces.component.tagcloud.TagCloud;
import org.primefaces.model.tagcloud.DefaultTagCloudItem;
import org.primefaces.model.tagcloud.DefaultTagCloudModel;
import org.primefaces.model.tagcloud.TagCloudModel;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Component;


/** 
 * Backing Bean for Page PresentationPage 
 */
@Component("presentationPage")
@Scope("access")
@ViewController(viewIds={"pages/Presentation/presentationPage.xhtml"})
public class PresentationPage extends PresentationPageGen {
	private TagCloudModel tagCloud;
	
	@PostConstruct
	public void initCloud() {
		tagCloud = new DefaultTagCloudModel();  
		tagCloud.addTag(new DefaultTagCloudItem("Transformers", 1));  
		tagCloud.addTag(new DefaultTagCloudItem("RIA", "/ui/tagCloud.jsf", 3));  
		tagCloud.addTag(new DefaultTagCloudItem("AJAX", 2));  
		tagCloud.addTag(new DefaultTagCloudItem("jQuery", "/ui/tagCloud.jsf", 5));  
		tagCloud.addTag(new DefaultTagCloudItem("NextGen", 4));  
		tagCloud.addTag(new DefaultTagCloudItem("JSF 2.0", "/ui/tagCloud.jsf", 2));  
		tagCloud.addTag(new DefaultTagCloudItem("openXMA", 5));  
		tagCloud.addTag(new DefaultTagCloudItem("Mobile",  3));  
		tagCloud.addTag(new DefaultTagCloudItem("Themes", "/ui/tagCloud.jsf", 4));  
		tagCloud.addTag(new DefaultTagCloudItem("Rocks", "/ui/tagCloud.jsf", 1));  
	}

	public TagCloudModel getTagCloud() {
		return tagCloud;
	}

	public void setTagCloud(TagCloudModel tagCloud) {
		this.tagCloud = tagCloud;
	}
}
